;============================================================================
;	MZ-1R23/1R24 ROMEROM zovO
;============================================================================

LETNL	EQU	0006h		; NEWLINE
MSGX	EQU	0018h		; PRINT LINE
WRI	EQU	0436h		; WRITE INFO
WRD	EQU	0475h		; WRITE DATA
WAITKEY	EQU	09B3h		; WAIT UNTIL KEYPRESS

ATRB	EQU	10F0h
NAME	EQU	10F1h
TSIZE	EQU	1102h		; TAPE DATA SIZE
TDADR	EQU	1104h		; TAPE DATA ADDRESS
TEADR	EQU	1106h		; TAPE EXEC ADDRESS

;----------------------------------------------------------------------------
;	C
;----------------------------------------------------------------------------
	ORG	1200h

	DI

	;
	;	MZ-1R23 zo
	;
	LD	DE, 0
	LD	B, 4		; 128KB = 32KB * 4
@2:	PUSH	BC
	LD	HL, 2000h	; ROMC[W̓ǂݍ݃AhX
	LD	BC, 1024	; ̓s1024(32KoCg)ɕď
@1:	CALL	readkanji	; p^[ǂݍ
	DEC	BC
	LD	A, B
	OR	C
	JR	NZ, @1b
	PUSH	DE
	CALL	LETNL
	LD	DE, mes_start
	CALL	MSGX
	CALL	WAITKEY
	LD	HL, 8000h	; SIZE: 32KoCg
	LD	(TSIZE), HL
	LD	HL, 2000h	; ADDR: 2000h
	LD	(TDADR), HL
	LD	HL, 00ADh	; EXEC: 00ADh (_~[)
	LD	(TEADR), HL
	CALL	tsave
	POP	DE
	POP	BC
	LD	HL, fnsub
	INC	(HL)
	DJNZ	@2b
	CALL	LETNL
	LD	DE, mes_done
	CALL	MSGX

	;
	;	MZ-1R24 zo
	;
	LD	HL, fnj		; t@C
	LD	DE, fn
	LD	BC, 6
	LDIR
	LD	DE, 0
	LD	B, 8		; 256KB = 32KB * 8
@2:	LD	A, 8
	SUB	B
	RRA
	OUT	(0B8h), A	; ROMANZXEoNԍZbg
	PUSH	BC
	LD	HL, 2000h	; ROMC[W̓ǂݍ݃AhX
	LD	BC, 8000h	; ̓s32KoCgɕď
@1:	CALL	readjisyo	; f[^ǂݍ
	DEC	BC
	LD	A, B
	OR	C
	JR	NZ, @1b
	PUSH	DE
	CALL	LETNL
	LD	DE, mes_start
	CALL	MSGX
	CALL	WAITKEY
	LD	HL, 8000h	; SIZE: 32KoCg
	LD	(TSIZE), HL
	LD	HL, 2000h	; ADDR: 2000h
	LD	(TDADR), HL
	LD	HL, 00ADh	; EXEC: 00ADh (_~[)
	LD	(TEADR), HL
	CALL	tsave
	POP	DE
	POP	BC
	LD	HL, fnsub
	INC	(HL)
	DJNZ	@2b
	CALL	LETNL
	LD	DE, mes_done
	CALL	MSGX

	JP	00ADh

;----------------------------------------------------------------------------
;	1 (32bytes) ROMǂ
;	IN:	HL = obt@AhX
;		DE = p^[ԍ
;	OUT:	(HL) = p^[f[^
;		HL += 32
;		DE++
;----------------------------------------------------------------------------
readkanji:
	PUSH	AF
	PUSH	BC

	LD	A, 080h		; Bit7: ROMZNg

	OUT	(0B8h), A	; MZ-1R23 Rg[
	LD	C, 0B9h
	LD	B, D		; p^[ԍ ʃoCg
	OUT	(C), E		; p^[ԍZbg
	LD	B, 32
	INIR			; 32oCgǂݍ
	LD	A, 20h
	OUT	(0B8h), A	; ǂݍݏI
	POP	BC
	POP	AF
	INC	DE		; p^[ԍ++
	RET

;----------------------------------------------------------------------------
;	f[^1oCgROMǂ
;	IN:	HL = obt@AhX
;		DE = ROMAhXi16bitj
;	OUT:	(HL) = f[^
;		HL++
;		DE++
;----------------------------------------------------------------------------
readjisyo:
	PUSH	AF
	PUSH	BC

	LD	C, 0B9h
	LD	B, D		; ROMAhX ʃoCg
	OUT	(C), E		; ROMAhXZbg
	INI			; f[^ǂ

	POP	BC
	POP	AF
	INC	DE		; p^[ԍ++
	RET

;
;	e[vɃZ[u
;	(TSIZE):f[^TCY (TDADR):X^[gAhX (TEADR):sAhX
;
tsave:
	CALL	LETNL
	LD	DE, mes_writing
	CALL	MSGX
	LD	DE, fn
	CALL	MSGX
	LD	HL, NAME
@@:	LD	A, (DE)
	INC	DE
	LD	(HL), A
	INC	HL
	CP	0Dh
	JR	NZ, @b
	LD	A, 01h
	LD	(ATRB), A
	CALL	WRI
	RET	C
	CALL	WRD
	RET

mes_writing:	DB	'WRITING ', 0Dh
mes_done:	DB	'OK!', 0Dh

mes_start:	DB	'PUSH ANY KEY TO SAVE '
fn:		DB	'KANJI'
fnsub:		DB	'0', 0Dh

fnj:		DB	'JISYO0'

	END
